ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
(Generate patch)

Comparing deliantra/server/utils/cfutil.in (file contents):
Revision 1.36 by root, Sun Jun 10 02:51:46 2007 UTC vs.
Revision 1.106 by root, Wed Oct 20 06:21:48 2010 UTC

1#!@PERL@ 1#!@PERL@
2 2
3use strict; 3#
4# This file is part of Deliantra, the Roguelike Realtime MMORPG.
5#
6# Copyright (©) 2007,2008,2009 Marc Alexander Lehmann / Robin Redeker / the Deliantra team
7#
8# Deliantra is free software: you can redistribute it and/or modify it under
9# the terms of the Affero GNU General Public License as published by the
10# Free Software Foundation, either version 3 of the License, or (at your
11# option) any later version.
12#
13# This program is distributed in the hope that it will be useful,
14# but WITHOUT ANY WARRANTY; without even the implied warranty of
15# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16# GNU General Public License for more details.
17#
18# You should have received a copy of the Affero GNU General Public License
19# and the GNU General Public License along with this program. If not, see
20# <http://www.gnu.org/licenses/>.
21#
22# The authors can be reached via e-mail to <support@deliantra.net>
23#
24
25use common::sense;
4 26
5my $prefix = "@prefix@"; 27my $prefix = "@prefix@";
6my $exec_prefix = "@exec_prefix@"; 28my $exec_prefix = "@exec_prefix@";
7my $datarootdir = "@datarootdir@"; 29my $datarootdir = "@datarootdir@";
8my $DATADIR = "@datadir@/@PACKAGE@"; 30my $DATADIR = "@datadir@/@PACKAGE@";
12my $OPTIPNG = "@OPTIPNG@"; 34my $OPTIPNG = "@OPTIPNG@";
13my $RSYNC = "@RSYNC@"; 35my $RSYNC = "@RSYNC@";
14my $PNGNQ = "@PNGNQ@"; 36my $PNGNQ = "@PNGNQ@";
15 37
16use Getopt::Long; 38use Getopt::Long;
39use File::Temp;
40use POSIX ();
41use Carp;
42
17use Coro::Event; 43use Coro::EV;
18use AnyEvent; 44use AnyEvent;
45use YAML::XS ();
46use JSON::XS ();
19use IO::AIO (); 47use IO::AIO ();
20use File::Temp; 48use Digest::MD5 ();
21use Crossfire; 49
22use Coro; 50use Coro 5.12;
23use Coro::AIO; 51use Coro::AIO;
24use POSIX (); 52use Coro::Util;
25use Digest::MD5; 53use Coro::Channel;
26use Coro::Storable; $Storable::canonical = 1; 54use Coro::Storable; $Storable::canonical = 1;
55
56use Deliantra;
57
58$SIG{QUIT} = sub { Carp::cluck "QUIT" };
27 59
28sub usage { 60sub usage {
29 warn <<EOF; 61 warn <<EOF;
30Usage: cfutil [-v] [-q] [--force] [--cache] 62Usage: cfutil [-v] [-q] [--force] [--cache]
31 [--install-arch path] 63 [--install-arch path]
42my $VERBOSE = 1; 74my $VERBOSE = 1;
43my $CACHE = 0; 75my $CACHE = 0;
44my $FORCE; 76my $FORCE;
45my $TMPDIR = "/tmp/cfutil$$~"; 77my $TMPDIR = "/tmp/cfutil$$~";
46my $TMPFILE = "aaaa0"; 78my $TMPFILE = "aaaa0";
79my @COMMIT;
47 80
48our %COLOR = ( 81our %COLOR = (
82 # original cf colours
49 black => 0, 83 black => 0,
50 white => 1, 84 white => 1,
51 navy => 2, 85 navy => 2, # "dark blue"
52 red => 3, 86 red => 3,
53 orange => 4, 87 orange => 4,
54 blue => 5, 88 blue => 5, # "light blue"
55 darkorange => 6, 89 darkorange => 6,
56 green => 7, 90 green => 7,
57 lightgreen => 8, 91 lightgreen => 8,
58 grey => 9, 92 grey => 9,
93 brown => 10, # "yellow"
94 gold => 11, # "light yellow"
95 tan => 12, # yellowish gray
96
97 # new for deliantra
59 brown => 10, 98 none => 13,
99
100 # compatibility to existing archetypes
101 lightblue => 5,
60 gold => 11, 102 gray => 9,
103 yellow => 11,
61 tan => 12, 104 khaki => 12,
62); 105);
63 106
64END { system "rm", "-rf", $TMPDIR } 107END { system "rm", "-rf", $TMPDIR }
65 108
66Event->signal (signal => "INT", cb => sub { exit 1 }); 109my $s_INT = EV::signal INT => sub { exit 1 };
67Event->signal (signal => "TERM", cb => sub { exit 1 }); 110my $s_TERM = EV::signal TERM => sub { exit 1 };
111
112our %hash;
113
114# here we could try to avoid collisions and reduce chksum size further
115sub make_hash($\$\$;$) {
116 my ($id, $dataref, $hashref, $clen) = @_;
117
118 my $hash = substr +(Digest::MD5::md5 $$dataref), 0, $clen || 4;
119
120 if (exists $hash{$hash}) {
121 # hash collision, but some files are simply identical
122 if (${$hash{$hash}[1]} ne $$dataref) {
123 warn "hash collision $hash{$hash}[0] vs. $id\n";
124 exit 1;
125 } else {
126 print "$hash{$hash}[0] and $id are identical (which is fine).\n" if $VERBOSE >= 3;
127 }
128 }
129 $hash{$hash} = [$id, $dataref, $hashref];
130
131 $$hashref = $hash;
132}
68 133
69mkdir $TMPDIR, 0700 134mkdir $TMPDIR, 0700
70 or die "$TMPDIR: $!"; 135 or die "$TMPDIR: $!";
71 136
72sub fork_sub(&) { 137sub fork_sub(&) {
92 if (!-f "$path/regions") { 157 if (!-f "$path/regions") {
93 warn "'$path' does not look like a maps directory ('regions' file is missing).\n"; 158 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
94 exit 1 unless $FORCE; 159 exit 1 unless $FORCE;
95 } 160 }
96 161
97 system $RSYNC, "-av", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded" 162 system $RSYNC, "-av", "--chmod=u=rwX,go=rX",
163 "$path/.", "$DATADIR/maps/.",
164 "--exclude", "CVS", "--exclude", "/world-precomposed",
165 "--delete", "--delete-excluded"
98 and die "map installation failed.\n"; 166 and die "map installation failed.\n";
99 167
100 print "maps installed successfully.\n"; 168 print "maps installed successfully.\n";
101} 169}
102 170
103{ 171{
104 our %ANIMINFO; 172 our %ANIMINFO;
105 our %FACEINFO; 173 our %FACEINFO;
174 our %RESOURCE;
106 our @ARC; 175 our @ARC;
107 our %ARC; 176 our %ARC;
108 our $TRS; 177 our $TRS;
109 our $NFILE; 178 our $NFILE;
179 our $PATH;
110 180
111 our $QUANTIZE = "+dither -colorspace RGB -colors 256"; 181 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
112 182
113 our (@png, @trs, @arc); # files we are interested in 183 our $c_arc = new Coro::Channel;
184 our $c_any = new Coro::Channel;
114 185
186 our @c_png;
187
115 sub commit_png($$$) { 188 sub commit_png($$$$) {
116 my ($name, $data, $T) = @_; 189 my ($stem, $name, $data, $T) = @_;
117 190
191 $FACEINFO{$name}{"stem"} = substr $stem, 1 + length $PATH;
118 $FACEINFO{$name}{"data$T"} = $data; 192 $FACEINFO{$name}{"data$T"} = $data;
119 } 193 }
120 194
121 sub process_png { 195 sub process_png {
122 while (@png) { 196 while (@c_png) {
123 my ($path, $delete) = @{pop @png}; 197 my ($path, $delete) = @{pop @c_png};
124 198
125 my $png; 199 my $png;
126 aio_lstat $path; 200 aio_lstat $path;
127 my ($size, $mtime) = (stat _)[7,9]; 201 my ($size, $mtime) = (stat _)[7,9];
128 202
159 if ($w % $T || $h % $T) { 233 if ($w % $T || $h % $T) {
160 warn "$path: weird png size ($w $h), skipping.\n"; 234 warn "$path: weird png size ($w $h), skipping.\n";
161 next; 235 next;
162 } 236 }
163 237
238 (my $base = $stem) =~ s/^.*\///;
239
240 my $fi = $FACEINFO{$base};
241 unless ($fi) {
242 #warn "$path: <$base> not referenced by any archetype, skipping.\n";
243 #next;
244 }
245
246 my $arc = $fi->{arc} || { };
247
164 unless ($path =~ /~$/) { 248 unless ($path =~ /~$/) {
165 # possibly enlarge 249 # possibly enlarge
166 if (0 > aio_stat "$stem.64x64.png") { 250 if (0 > aio_stat "$stem.64x64.png") {
167 my $other = "$stem.64x64.png~"; 251 my $other = "$stem.64x64.png~";
168 252
169 if (0 > aio_lstat $other or (-M _) > (-M $path)) { 253 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
170 my $wrap = 0; # for the time being
171 fork_sub { 254 fork_sub {
255 my $CROP;
256 my $SRC = "png:\Q$path\E";
257
258 my $is_floor = $arc->{is_floor};
259 my $is_wall = 0;
260
261 my ($wall_pfx, $wall_dir, $wall_sfx);
262
263 if (
264 !$is_floor
265 && !$arc->{alive}
266 && $arc->{move_block} eq "all"
267 && $path =~ /^(.*_)([0-9A-F])(\.x11.*\.png)$/
268 ) {
269 ($wall_pfx, $wall_dir, $wall_sfx) = ($1, hex $2, $3);
270
271 unless (grep { !-e sprintf "%s%X%s", $wall_pfx, $_, $wall_sfx } 0..15) {
272 $is_wall = 1;
273 }
274 }
275
276 if ($is_wall || $is_floor) {
277 # add a 4px border and add other images around it
278 $CROP = "-shave 8x8 +repage";
279
280 $w += 8;
281 $h += 8;
282
283 $SRC = "-size ${w}x${h} xc:transparent";
284 $SRC .= " png:\Q$path\E -geometry +4+4 -composite";
285
286 # 8 surrounding images
287 for (
288 # x y b r0 r1
289 [-1, -1, 0, 6],
290 [ 0, -1, 1, 10, 14],
291 [+1, -1, 0, 12],
292
293 [-1, 0, 8, 5, 7],
294 #
295 [+1, 0, 2, 5, 13],
296
297 [-1, +1, 0, 3],
298 [ 0, +1, 4, 10, 11],
299 [+1, +1, 0, 9],
300 ) {
301 my ($x, $y, $d, $r0, $r1) = @$_;
302
303 my $tile = $is_floor ? $path
304 : $is_wall ? sprintf "%s%X%s", $wall_pfx, ($wall_dir & $d) ? $r1 : $r0, $wall_sfx
305 : die;
306
307 $SRC .= sprintf " png:%s -geometry %+d%+d -composite",
308 "\Q$tile",
309 $x * ($w - 8) + 4,
310 $y * ($h - 8) + 4;
311 }
312 }
313
172 system "convert png:\Q$path\E -depth 8 rgba:-" 314 system "convert -depth 8 $SRC rgba:-"
173 . "| $exec_prefix/bin/cfhq2xa $w $h $wrap" 315 . "| $exec_prefix/bin/cfhq2xa $w $h 0"
174 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $QUANTIZE -quality 00 png32:\Q$other\E~" 316 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $CROP $QUANTIZE -quality 00 png32:\Q$other\E~"
175 and die "convert/hq2xa pipeline error: status $? ($!)"; 317 and die "convert/cfhq2xa pipeline error: status $? ($!)";
176 system $OPTIPNG, "-i0", "-q", "$other~"; 318 system $OPTIPNG, "-i0", "-q", "$other~";
177 die "$other~ has zero size, aborting." unless -s "$other~"; 319 die "$other~ has zero size, aborting." unless -s "$other~";
178 rename "$other~", $other; 320 rename "$other~", $other;
179 }; 321 };
180 } 322 }
181 323
182 push @png, [$other, !$CACHE]; 324 push @c_png, [$other, !$CACHE];
183 } 325 }
184 326
185 # possibly scale down 327 # possibly scale down
186 if (0 > aio_stat "$stem.32x32.png") { 328 if (0 > aio_stat "$stem.32x32.png") {
187 my $other = "$stem.32x32.png~"; 329 my $other = "$stem.32x32.png~";
190 fork_sub { 332 fork_sub {
191 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~"; 333 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~";
192 system $OPTIPNG, "-i0", "-q", "$other~"; 334 system $OPTIPNG, "-i0", "-q", "$other~";
193 335
194 # reduce smoothfaces >10000 bytes 336 # reduce smoothfaces >10000 bytes
337 # obsolete, no longer required
195 if ($stem =~ /_S\./ && (-s "$other~") > 10000) { 338 if (0 && $stem =~ /_S\./ && (-s "$other~") > 10000) {
196 my $ncolor = 256; 339 my $ncolor = 256;
197 while () { 340 while () {
198 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E"; 341 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E";
199 system $OPTIPNG, "-i0", "-q", "$other~~"; 342 system $OPTIPNG, "-i0", "-q", "$other~~";
200 last if 10000 > -s "$other~~"; 343 last if 10000 > -s "$other~~";
212 rename "$other~", $other; 355 rename "$other~", $other;
213 }; 356 };
214 } 357 }
215 358
216 #warn "scaled down $path to $other\n";#d# 359 #warn "scaled down $path to $other\n";#d#
217 push @png, [$other, !$CACHE]; 360 push @c_png, [$other, !$CACHE];
218 } 361 }
219 } 362 }
220 363
221 (my $face = $stem) =~ s/^.*\///; 364 (my $face = $stem) =~ s/^.*\///;
222 365
271 414
272 if (0 > aio_load $file, $tile) { 415 if (0 > aio_load $file, $tile) {
273 die "$path: unable to read tile +$x+$y, aborting.\n"; 416 die "$path: unable to read tile +$x+$y, aborting.\n";
274 } 417 }
275 IO::AIO::aio_unlink $file unless $CACHE; 418 IO::AIO::aio_unlink $file unless $CACHE;
276 commit_png $x|$y ? "$face+$x+$y" : $face, $tile, $T; 419 commit_png $stem, $x|$y ? "$face+$x+$y" : $face, $tile, $T;
277 } 420 }
278 } else { 421 } else {
279 # use as-is (either small, use smooth) 422 # use as-is (either small, use smooth)
280 commit_png $face, $png, $T; 423 commit_png $stem, $face, $png, $T;
281 } 424 }
282 425
283 aio_unlink $path if $delete; 426 aio_unlink $path if $delete;
284 } 427 }
285 } 428 }
286 429
430 sub process_faceinfo {
431 my ($dir, $file) = @_;
432 my $path = "$dir/$file";
433
434 my $data;
435 if (0 > aio_load $path, $data) {
436 warn "$path: $!, skipping.\n";
437 return;
438 }
439
440 for (split /\n/, $data) {
441 chomp;
442 my ($face, $visibility, $fg, $bg, $glyph) = split /\s+/;
443 # bg not used except for text clients
444
445 utf8::decode $glyph;
446 $glyph =~ s/^\?(?=.)//; # remove "autoglyph" flag
447
448 $fg = "white" if $fg eq "none"; # lots of faces have no fg colour yet
449
450 (my $fgi = $COLOR{$fg})
451 // warn "WARNING: $path: $face specifies unknown foreground colour '$fg'.\n";
452 (my $bgi = $COLOR{$bg})
453 // warn "WARNING: $path: $face specifies unknown background colour '$bg'.\n";
454
455 my $fi = $FACEINFO{$face} ||= { };
456 $fi->{visibility} = $visibility * 1;
457 $fi->{magicmap} = $fgi; # foreground colour becomes magicmap
458
459 $glyph .= " " if 2 > length $glyph; # TODO kanji
460
461 $fi->{glyph} = "";
462 for (split //, $glyph, -1) {
463 utf8::encode $_;
464 $fi->{glyph} .= (chr $fgi) . (chr $bgi) . $_;
465 }
466 }
467 }
468
287 sub process_arc { 469 sub process_arc {
288 while (@arc) { 470 while (my ($dir, $file) = @{ $c_arc->get }) {
289 my ($dir, $file) = @{pop @arc};
290
291 my $arc; 471 my $arc;
292 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/ 472 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/
293 473
294 my $arc = read_arch "$dir/$file"; 474 my $arc = read_arch "$dir/$file";
295 for my $o (values %$arc) { 475 for my $o (values %$arc) {
296 push @ARC, $o; 476 push @ARC, $o;
297 for (my $m = $o; $m; $m = $m->{more}) { 477 for (my $m = $o; $m; $m = $m->{more}) {
298 $ARC{$m->{_name}} = $m; 478 $ARC{$m->{_name}} = $m;
299 } 479 }
300 480
301 $o->{editor_folder} = $dir; 481 $o->{editor_folder} ||= "\x00$dir"; # horrible kludge
302
303 my $visibility = delete $o->{visibility};
304 my $magicmap = delete $o->{magicmap};
305 482
306 # find upper left corner :/ 483 # find upper left corner :/
307 # omg, this is sooo broken 484 # omg, this is sooo broken
308 my ($dx, $dy); 485 my ($dx, $dy);
309 for (my $o = $o; $o; $o = $o->{more}) { 486 for (my $o = $o; $o; $o = $o->{more}) {
316 my $y = $o->{y} - $dy; 493 my $y = $o->{y} - $dy;
317 494
318 my $ext = $x|$y ? "+$x+$y" : ""; 495 my $ext = $x|$y ? "+$x+$y" : "";
319 496
320 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face}; 497 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face};
321
322 $visibility = delete $o->{visibility} if exists $o->{visibility};
323 $magicmap = delete $o->{magicmap} if exists $o->{magicmap};
324 498
325 my $anim = delete $o->{anim}; 499 my $anim = delete $o->{anim};
326 500
327 if ($anim) { 501 if ($anim) {
328 # possibly add $ext to the animation name to avoid 502 # possibly add $ext to the animation name to avoid
346 facings => $facings, 520 facings => $facings,
347 frames => \@frames, 521 frames => \@frames,
348 }; 522 };
349 } 523 }
350 524
351 for my $face ($o->{face} || (), @{$anim || []}) { 525 for ($o->{face} || (), @{$anim || []}) {
352 next if $face =~ /^facings\s|^blank.x11$|^empty.x11$/; 526 next if /^facings\s/;
353 527
528 my $face = $_;
529 $face =~ s/\+\d+\+\d+$//; # remove tile offset coordinates
530
354 my $info = $FACEINFO{$face} ||= {}; 531 my $info = $FACEINFO{$face} ||= { };
532 $info->{arc} = $o;
355 533
356 $info->{visibility} = $visibility if defined $visibility; 534 next if $face =~ /^blank.x11$|^empty.x11$/;
357 $info->{magicmap} = $magicmap if defined $magicmap;
358 } 535 }
359 536
360 if (my $smooth = delete $o->{smoothface}) { 537 if (my $smooth = delete $o->{smoothface}) {
361 my %kv =split /\s+/, $smooth; 538 my %kv = split /\s+/, $smooth;
362 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support 539 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support
363 while (my ($face, $smooth) = each %kv) { 540 while (my ($face, $smooth) = each %kv) {
541 $FACEINFO{$smooth}{arc} = $o;
542
364 $FACEINFO{$face}{smooth} = $smooth; 543 $FACEINFO{$face}{smooth} = $smooth;
365 $FACEINFO{$face}{smoothlevel} = $level; 544 $FACEINFO{$face}{smoothlevel} = $level;
366 } 545 }
367 } 546 }
368 } 547 }
369 } 548 }
370 } 549 }
371 } 550 }
372 551
373 sub process_trs { 552 sub process_trs {
374 while (@trs) {
375 my ($dir, $file) = @{pop @trs}; 553 my ($dir, $file) = @_;
376 my $path = "$dir/$file"; 554 my $path = "$dir/$file";
377 555
378 my $trs; 556 my $trs;
379 if (0 > aio_load $path, $trs) { 557 if (0 > aio_load $path, $trs) {
380 warn "$path: $!, skipping.\n"; 558 warn "$path: $!, skipping.\n";
381 next; 559 return;
382 } 560 }
383 561
384 $TRS .= $trs; 562 $TRS .= $trs;
563 }
564
565 my %FILECACHE;
566
567 sub load_cached($;$) {
568 unless (exists $FILECACHE{$_[0]}) {
569 my $data;
570 if (0 < aio_load $_[0], $data) {
571 if ($_[1]) {
572 $data = eval { $_[1]->($data) };
573 warn "$_[0]: $@" if $@;
574 }
575 }
576
577 $FILECACHE{$_[0]} = $data;
578 }
579
580 $FILECACHE{$_[0]}
581 }
582
583 sub process_res {
584 my ($dir, $file, $type) = @_;
585
586 my $data;
587 aio_load "$dir/$file", $data;
588
589 my $meta = load_cached "$dir/meta", sub { JSON::XS->new->utf8->relaxed->decode (shift) };
590
591 utf8::decode $dir;
592 utf8::decode $file;
593
594 # a meta file for resources is now mandatory
595 unless (exists $meta->{$file}) {
596 warn "skipping $dir/$file\n" if $VERBOSE >= 3;
597 return;
598 }
599
600 $meta = {
601 %{ $meta->{"" } || {} },
602 %{ $meta->{$file} || {} },
603 };
604
605 if ($meta->{license} =~ s/^#//) {
606 $meta->{license} = ({
607 "pd" => "Public Domain",
608 "gpl" => "GNU General Public License, version 3.0 or any later",
609 "cc/by/2.0" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.0/",
610 "cc/by/2.1" => "Licensed under Creative Commons Attribution 2.1 http://creativecommons.org/licenses/by/2.1/",
611 "cc/by/2.5" => "Licensed under Creative Commons Attribution 2.5 http://creativecommons.org/licenses/by/2.5/",
612 "cc/by/3.0" => "Licensed under Creative Commons Attribution 3.0 http://creativecommons.org/licenses/by/3.0/",
613 })->{$meta->{license}}
614 || warn "$dir/$file: license tag '$meta->{license}' not found.";
615 }
616
617 if (!exists $meta->{author} && $meta->{source} =~ m%^http://www.jamendo.com/en/artist/(.*)$%) {
618 ($meta->{author} = $1) =~ s/_/ /g;
619 }
620
621 $file =~ s/\.res$//;
622 $file =~ s/\.(ogg|wav|jpg|png)$//;
623
624 substr $dir, 0, 1 + length $PATH, "";
625
626 if (my $filter = $meta->{cfutil_filter}) {
627 if ($filter eq "yaml2json") {
628 $data = JSON::XS::encode_json YAML::XS::Load $data;
629 } elsif ($filter eq "json2json") {
630 $data = JSON::XS::encode_json JSON::XS->relaxed->utf8->decode ($data);
631 } elsif ($filter eq "perl2json") {
632 $data = eval $data; die if $@;
633 $data = JSON::XS::encode_json $data;
634 } else {
635 warn "$dir/$file: unknown filter $filter, skipping\n";
636 }
637 }
638
639 $RESOURCE{"$dir/$file"} = {
640 type => (exists $meta->{type} ? delete $meta->{type} : $type),
641 data => $data,
642 %$meta ? (meta => $meta) : (),
643 };
644 }
645
646 sub process_any {
647 while (my ($func, @args) = @{ $c_any->get }) {
648 $func->(@args);
385 } 649 }
386 } 650 }
387 651
388 sub find_files; 652 sub find_files;
389 sub find_files { 653 sub find_files {
390 my ($path) = @_; 654 my ($path) = @_;
391 655
656 my $grp = IO::AIO::aio_group;
657
658 my $scandir; $scandir = sub {
659 my ($path) = @_;
660
392 IO::AIO::aioreq_pri 4; 661 IO::AIO::aioreq_pri 4;
393 IO::AIO::aio_scandir $path, 4, sub { 662 add $grp IO::AIO::aio_scandir $path, 4, sub {
394 my ($dirs, $nondirs) = @_; 663 my ($dirs, $nondirs) = @_;
395 664
396 find_files "$path/$_" 665 $scandir->("$path/$_")
397 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs; 666 for grep $_ !~ /^(?:CVS|dev|\..*)$/, @$dirs;
398 667
668 my $dir = $path;
669 substr $dir, 0, 1 + length $PATH, "";
670
399 for my $file (@$nondirs) { 671 for my $file (@$nondirs) {
672 if ($dir =~ /^music(?:\/|$)/) {
673 $c_any->put ([\&process_res, $path, $file, 3]) # FT_MUSIC
674 if $file =~ /\.(ogg)$/;
675
676 } elsif ($dir =~ /^sound(?:\/|$)/) {
677 $c_any->put ([\&process_res, $path, $file, 5]) # FT_SOUND
678 if $file =~ /\.(wav|ogg)$/;
679
680 } elsif ($dir =~ /^res(?:\/|$)/) {
681 if ($file =~ /\.(jpg|png)$/) {
682 $c_any->put ([\&process_res, $path, $file, 0]) # FT_FACE
683 } elsif ($file =~ /\.(res)$/) {
684 $c_any->put ([\&process_res, $path, $file, 6]) # FT_RSRC
685 } else {
686 $c_any->put ([\&process_res, $path, $file, undef]);
687 }
688
400 if ($file =~ /\.png$/) { 689 } elsif ($file =~ /\.png$/) {
401 push @png, ["$path/$file", 0]; 690 push @c_png, ["$path/$file", 0];
691
692 } elsif ($file =~ /\.faceinfo$/) {
693 $c_any->put ([\&process_faceinfo, $path, $file]);
694
402 } elsif ($file =~ /\.trs$/) { 695 } elsif ($file =~ /\.trs$/) {
403 push @trs, [$path, $file]; 696 $c_any->put ([\&process_trs, $path, $file]);
697
404 } elsif ($file =~ /\.arc$/) { 698 } elsif ($file =~ /\.arc$/) {
405 push @arc, [$path, $file]; 699 $c_arc->put ([$path, $file]);
700
406 } else { 701 } else {
407 warn "ignoring $path/$file\n" if $VERBOSE >= 3; 702 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
408 } 703 }
704 }
409 } 705 };
410 }; 706 };
707
708 $scandir->($path);
709 aio_wait $grp;
710 }
711
712 sub generate_plurals {
713# use Lingua::EN::Inflect ();
714# Lingua::EN::Inflect::classical;
715# Lingua::EN::Inflect::def_noun '(.*)staff' => '$1staves'; # policy
716# Lingua::EN::Inflect::def_noun '(.*)boots' => '$1boots'; # hack
717#
718# for my $a (@ARC) {
719# my $name = $a->{name} || $a->{_name};
720#
721# next unless $a->{name_pl};
722# next if $a->{invisible};
723# next if $a->{is_floor};
724# next if $a->{no_pick};
725#
726# my $test = Lingua::EN::Inflect::PL_N_eq $name, Lingua::EN::Inflect::PL $name;
727# my $pl = $test =~ /^(?:eq|p:.)$/
728# ? $name
729# : Lingua::EN::Inflect::PL $name;
730#
731# if ($pl ne $a->{name_pl}) {
732# warn "$a->{_name}: plural differs, $pl vs $a->{name_pl}\n";
733# }
734# }
411 } 735 }
412 736
413 sub inst_arch($) { 737 sub inst_arch($) {
414 my (undef, $path) = @_; 738 my (undef, $path) = @_;
739
740 $PATH = $path;
415 741
416 print "\n", 742 print "\n",
417 "Installing '$path' to '$DATADIR'\n", 743 "Installing '$path' to '$DATADIR'\n",
418 "\n", 744 "\n",
419 "This can take a long time if you run this\n", 745 "This can take a long time if you run this\n",
426 if (!-d "$path/treasures") { 752 if (!-d "$path/treasures") {
427 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n"; 753 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n";
428 exit 1 unless $FORCE; 754 exit 1 unless $FORCE;
429 } 755 }
430 756
757 print "start file scan, arc, any processing...\n" if $VERBOSE;
758
759 my @a_arc = map +(async \&process_arc), 1..2;
760 my @a_any = map +(async \&process_any), 1..4;
761
431 find_files $path; 762 find_files $path;
432 IO::AIO::flush;
433 763
434 $_->join for ( 764 $c_arc->shutdown;
765 $c_any->shutdown;
766
767 $_->join for @a_arc; # need to parse all archetypes before png processing
768
769 print "end arc, start png processing...\n" if $VERBOSE;
770
435 # four png crunchers work fine for my 2x smp machine 771 # eight png crunchers work fine for my 4x smp machine
436 (async \&process_png), (async \&process_png), (async \&process_png), (async \&process_png), 772 my @a_png = map +(async \&process_png), 1..8;
437 (async \&process_trs), (async \&process_trs),
438 (async \&process_arc), (async \&process_arc),
439 );
440 773
774 print "end any processing...\n" if $VERBOSE;
775 $_->join for @a_any;
776
777 print "end png processing...\n" if $VERBOSE;
778 $_->join for @a_png;
779
780 print "scanning done, processing results...\n" if $VERBOSE;
441 { 781 {
442 # remove path prefix from editor_folder 782 # remove path prefix from editor_folder
783 $_->{editor_folder} =~ /^\x00/
443 substr $_->{editor_folder}, 0, 1 + length $path, "" 784 and substr $_->{editor_folder}, 0, 2 + length $path, ""
444 for values %ARC; 785 for values %ARC;
445 786
787 print "resolving inheritance tree...\n" if $VERBOSE;
446 # resolve inherit 788 # resolve inherit
447 while () { 789 while () {
448 my $progress; 790 my $progress;
449 my $loop; 791 my $loop;
450 792
451 for my $o (values %ARC) { 793 for my $o (values %ARC) {
452 if (my $other = $o->{inherit}) { 794 for my $other (split /,/, $o->{inherit}) {
453 if (my $s = $ARC{$other}) { 795 if (my $s = $ARC{$other}) {
454 if ($s->{inherit}) { 796 if ($s->{inherit}) {
455 $loop = $s; 797 $loop = $s;
456 } else { 798 } else {
457 delete $o->{inherit}; 799 delete $o->{inherit};
459 delete @s{qw(_name more name name_pl)}; 801 delete @s{qw(_name more name name_pl)};
460 %$o = ( %s, %$o ); 802 %$o = ( %s, %$o );
461 ++$progress; 803 ++$progress;
462 } 804 }
463 } else { 805 } else {
464 warn "'$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n"; 806 warn "WARNING: archetype '$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n";
465 delete $ARC{$o->{_name}}; 807 delete $ARC{$o->{_name}};
466 } 808 }
467 } 809 }
468 } 810 }
469 811
476 } 818 }
477 819
478 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit 820 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit
479 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC; 821 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC;
480 822
823 # fix up archetypes without names, where the archanme doesn't work at all
824 for (@ARC) {
825 if (!exists $_->{name} and $_->{_name} =~ /_/) {
826 for ($_->{name} = $_->{_name}) {
827 s/(?:_\d+)+$//;
828 s/_[nesw]+$//;
829 y/_/ /;
830 }
831 }
832 }
833
834 #print "generating plurals...\n" if $VERBOSE;
835 #generate_plurals;
836
837 printf "writing %d archetypes...\n", scalar @ARC if $VERBOSE;
481 open my $fh, ">:utf8", "$DATADIR/archetypes~" 838 open my $fh, ">:utf8", "$DATADIR/archetypes~"
482 or die "$DATADIR/archetypes~: $!"; 839 or die "$DATADIR/archetypes~: $!";
483 print $fh Crossfire::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC]; 840 print $fh Deliantra::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC];
484 } 841 }
485 842
486 { 843 {
844 printf "writing treasures (%d octets)...\n", length $TRS if $VERBOSE;
487 open my $fh, ">:utf8", "$DATADIR/treasures~" 845 open my $fh, ">:utf8", "$DATADIR/treasures~"
488 or die "$DATADIR/treasures~: $!"; 846 or die "$DATADIR/treasures~: $!";
489 print $fh $TRS; 847 print $fh $TRS;
490 } 848 }
491 849
492 { 850 {
851 print "processing facedata...\n" if $VERBOSE;
493 while (my ($k, $v) = each %FACEINFO) { 852 while (my ($k, $v) = each %FACEINFO) {
494 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n"; 853 length $v->{data32} or warn "WARNING: face '$k' has no png32. this will not work (shoddy gcfclient will crash of course).\n";
495 length $v->{data64} or warn "$k: face has no png64. this will not work very well.\n"; 854 length $v->{data64} or warn "WARNING: face '$k' has no png64. this will not work very well.\n";
496 855
856 make_hash $k, $v->{data32}, $v->{hash32};
857 make_hash $k, $v->{data64}, $v->{hash64};
858
497 length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n"; 859 #length $v->{data32} <= 10000 or warn "WARNING: face '$k' has face32 larger than 10000 bytes, will not work with crossfire client.\n";
498 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n"; 860 #length $v->{data64} <= 10000 or warn "WARNING: face '$k' has face64 larger than 10000 bytes.\n";
499 861
500 $v->{chksum32} = Digest::MD5::md5 $v->{data32}; 862 $v->{glyph} // warn "WARNING: face '$k' has glyph.";
501 $v->{chksum64} = Digest::MD5::md5 $v->{data64}; 863 $v->{visibility} // warn "WARNING: face '$k' has no visibility info, missing faceinfo entry?\n";
864 $v->{magicmap} // warn "WARNING: face '$k' has foreground colour.";
502 865
503 if (my $magicmap = $v->{magicmap}) { 866 delete @$v{qw(arc stem)}; # not used by the server
504 $magicmap =~ y/A-Z_\-/a-z/d; 867 }
505 $v->{magicmap} = $COLOR{$magicmap}; 868
869 print "processing resources...\n" if $VERBOSE;
870 my $enc = JSON::XS->new->utf8->canonical->relaxed;
871 while (my ($k, $v) = each %RESOURCE) {
872
873 if ($v->{meta} && $v->{meta}{datadir}) {
874 delete $RESOURCE{$k};
875
876 $k =~ s/^res\/// or die "$k: datadir files must be in res/";
877
878 printf "writing $k (%d octets)...\n", length $v->{data} if $VERBOSE;
879 open my $fh, ">:raw", "$DATADIR/$k~"
880 or die "$DATADIR/$k~: $!";
881 syswrite $fh, $v->{data};
882 push @COMMIT, $k;
883
884 } else {
885 if ($v->{type} & 1) {
886 # prepend meta info
887
888 my $meta = $enc->encode ({
889 name => $k,
890 %{ $v->{meta} || {} },
891 });
892
893 $v->{data} = pack "(w/a*)*", $meta, $v->{data};
506 } 894 }
895
896 make_hash $k, $v->{data}, $v->{hash}, 6; # 6 for the benefit of existing clients
507 } 897 }
898 }
899
900 printf "writing facedata (%d faces, %d anims, %d resources)...\n",
901 scalar keys %FACEINFO,
902 scalar keys %ANIMINFO,
903 scalar keys %RESOURCE
904 if $VERBOSE;
508 905
509 open my $fh, ">:perlio", "$DATADIR/facedata~" 906 open my $fh, ">:perlio", "$DATADIR/facedata~"
510 or die "$DATADIR/facedata~: $!"; 907 or die "$DATADIR/facedata~: $!";
511 908
512 print $fh freeze { 909 print $fh nfreeze {
513 version => 2, 910 version => 2,
514 faceinfo => \%FACEINFO, 911 faceinfo => \%FACEINFO,
515 animinfo => \%ANIMINFO, 912 animinfo => \%ANIMINFO,
913 resource => \%RESOURCE,
516 }; 914 };
517 }
518 915
916 }
917
918 print "committing files...\n" if $VERBOSE;
919
519 for (qw(archetypes facedata treasures)) { 920 for (qw(archetypes facedata treasures), @COMMIT) {
520 chmod 0644, "$DATADIR/$_~"; 921 chmod 0644, "$DATADIR/$_~";
521 rename "$DATADIR/$_~", "$DATADIR/$_" 922 rename "$DATADIR/$_~", "$DATADIR/$_"
522 or die "$DATADIR/$_: $!"; 923 or die "$DATADIR/$_: $!";
523 } 924 }
524 925

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines